<template>
  <section>
    <v-data-table
      locale="es-PE"
      :headers="headers"
      :items="people"
      sort-by="name"
      class="elevation-1"
      :loading="wait" loading-text="Cargando...Porfavor Espere"
    >
      <template v-slot:top>
        <v-toolbar flat color="white">
          <v-toolbar-title>Personas</v-toolbar-title>
          <v-divider
            class="mx-4"
            inset
            vertical
          ></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" max-width="500px">
            <template v-slot:activator="{ on }">
              <v-btn color="teal darken-2" dark class="mb-2" v-on="on">Agregar Persona</v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="headline">{{ formTitle }}</span>
              </v-card-title>

              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12">
                      <v-text-field v-model="editedItem.name" label="Nombres"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="12">
                      <v-text-field v-model="editedItem.lastname" label="Apellido Paterno"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="12">
                      <v-text-field v-model="editedItem.motherlastname" label="Apellido Materno"></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-text-field v-model="editedItem.maritalstatus" label="Estado Civil"></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-text-field v-model="editedItem.gender" label="Sexo"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field v-model="editedItem.typedocument" label="Tipo de Documento"></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-text-field v-model="editedItem.numberdocument" label="Número de Documento"></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-text-field v-model="editedItem.placebirth" label="Lugar de Nacimiento"></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-text-field v-model="editedItem.birthdate" label="Fecha de Nacimiento"></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="teal darken-2" text @click="close">Cancel</v-btn>
                <v-btn color="teal darken-2" text @click="save">Save</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:item.action="{ item }">
        <v-icon
          small
          class="mr-2"
          @click="editItem(item)"
        >
          edit
        </v-icon>
        <v-icon
          small
          @click="deleteItem(item)"
        >
          delete
        </v-icon>
      </template>

      <template v-slot:no-data>
        <v-row>
          <v-col cols="12" sm="6" offset-sm="3">
            <v-alert type="info">
              No hay personas registradas
            </v-alert>
          </v-col>
        </v-row>
      </template>
    </v-data-table>

    
  </section>
</template>

<script>

import { mapActions, mapGetters } from "vuex";

export default {
    data: () => ({
      wait: true,
      dialog: false,
      headers: [
        {
          text: 'Nombre',
          align: 'left',
          value: 'name',
        },
        {
          text: 'Apellido Paterno',
          align: 'left',
          value: 'lastname',
        },
        {
          text: 'Apellido Materno',
          align: 'left',
          value: 'motherlastname',
        },
        { text: 'Estado Civil', value: 'maritalstatus' },
        { text: 'Sexo', value: 'gender', sortable: false },
        { text: 'Tipo de Documento', value: 'typedocument' },
        { text: 'Número de Documento', value: 'numberdocument' },
        { text: 'Lugar de Nacimiento', value: 'placebirth', sortable: false },
        { text: 'Fecha de Nacimiento', value: 'birthdate' },
        { text: 'Acciones', value: 'action', sortable: false },
      ],
      people: [],
      editedIndex: -1,
      editedItem: {
        id: '',
        name: '',
        lastname: '',
        motherlastname: '',
        maritalstatus: '',
        gender: '',
        typedocument: '',
        numberdocument: '',
        placebirth: '',
        birthdate: ''
      },
      defaultItem: {
        id: '',
        name: '',
        lastname: '',
        motherlastname: '',
        maritalstatus: '',
        gender: '',
        typedocument: '',
        numberdocument: '',
        placebirth: '',
        birthdate: ''
      },
    }),

    computed: {
      ...mapGetters("Person", ["personsList"]),

      formTitle () {
        return this.editedIndex === -1 ? 'Agregar Persona' : 'Editar Persona'
      },
    },

    watch: {
      dialog (val) {
        val || this.close()
      },
    },

    created () {
      this.initialize()
    },

    methods: {
      ...mapActions("Person", ["getAllPersons", "createPerson", "deletePerson", "updatePerson"]),

      async initialize () {
        await this.getAllPersons()
        
        this.people = this.personsList.data
        this.wait = false
      },

      editItem (item) {
        this.editedIndex = this.people.indexOf(item)
        this.editedItem = Object.assign({}, item)
        this.dialog = true
      },

      async deleteItem (item) {
        if (confirm('¿Seguro que quieres borrar este registro?')) {
          await this.deletePerson(item.id)

          this.people.splice(index, 1)
        }
      },

      close () {
        this.dialog = false
        setTimeout(() => {
          this.editedItem = Object.assign({}, this.defaultItem)
          this.editedIndex = -1
        }, 300)
      },

      async save () {
        if (this.editedIndex > -1) {
          const data = {
            personId: this.editedItem.id,
            person: this.editedItem
          }
          
          await this.updatePerson(data)

          Object.assign(this.people[this.editedIndex], this.editedItem)
        } else {
          const person = this.editedItem
          await this.createPerson(person)
        }
        this.close()
      },
    },
  }
</script>
